<chapter xmlns="http://docbook.org/ns/docbook" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:xi="http://www.w3.org/2001/XInclude" version="5.0" xml:lang="hu">
    <info>
        <title>Helló, Berners-Lee! - Olvasónapló</title>
        <keywordset>
            <keyword/>
        </keywordset>
    </info>

    <section>
        <title>C++ vs Java</title>
        <para>
            C++: Benedek Zoltán, Levendovszky Tihamér Szoftverfejlesztés C++ nyelven
        </para>
		<para>
            Java: Nyékyné Dr. Gaizler Judit et al. Java 2 útikalauz programozóknak 5.0 I-
        </para>
		<para>
            Ebből a két könyvből pár oldalas esszé jellegű kidolgozást kérek, Java és C++
			összehasonlítás mentén, pl. kb.: kifejezés fogalom ua., Javában minden objektum
			referencia, mindig dinamikus a kötés, minden függvény virtuális, klónozás stb.
        </para>
		<para>
            A Java nyelv, mint a C++, egy objektumorientált nyelv, a programok
            osztályok és az ezekből létrehozott objektumok egésze.
        </para>       
        <para>
            A két legfőbb különbség a két nyelv között az, hogy míg a C++ egy natív
            nyelv, azaz gépikódot állít elő a fordító (tényleges architektúrán fog futni),
            addig a Java kód fordítása Javabytekódot eredményez amit majdan
            futtatáskor a Java Virtuális Gép fog végrehajtani(mint interpreter), utóbbi lehetővé teszi,
            hogy minden egyes olyan rendszeren/architektúrán amelyre meg lett írva a JVM,
            azon biztosan futni fog a már megírt Java kód, tehát a Java, virtuális
            gépének köszönhetően, "valódi" cross-platform nyelv. C++ esetén
            az előállított binárisokat nem nagyon tudjuk hurcolászni, például egy
            Arch Linux rendszer alatt lefordított C++ program nem fog működni egy
            Ubuntu rendszeren.
        </para>
        <para>
            Mi ennek a hordozhatóságnak az eredménye? A nyelv sokkal szigorúbb lesz
            nyelvi elemeivel kapcsolatban, tehát például belső szerkezetükkel kapcsolatban
            (gondolni kell hordozhatóság miatt például a bájtok felírási sorrendjére),
            típusok méretére...
        </para>
        <para>
            Természetesen, ha szoftvert fejlesztünk nem ez az első lépés, hiszen
            előbb a programunk elméleti hátterét kell kiterveznünk s a többi, de alapvetően
            a rendszerünkön a szoftverfejlesztés megkezdést azt jelenti, hogy megírjuk
            a programunkat a választott nyelven, ez esetben Javaban.
        </para>
        <para>
            Miután legépeltük alaposan megtervezett megoldásunkat le kell fordítanunk
            a Java forrásfájlokat az interpreter számára értelmezhető formára.
        </para>
        <para>
            A kapott forrást valamilyen válaszott disztibúciós módszerrel szétterjesztük
            a célközönség számára.
        </para>
        <para>
            Végrehajtódásra kerül a JVM által a kódunk.
        </para>
        <para>
            Figyeljük és supportáljuk megoldásunkat, akár távolról kalibráljuk a futtató környezetet.
        </para>
		<para>
			Platformváltozatok
		</para>
		<para>
			JRE: a futtatáshoz szükséges környezet
		</para>
        <para>
            JDK: programfejlesztéshez szükséges eszközök
        </para>
		<para>
		   Szintaxisról
		</para>
        <para>
            A Java nyelvi elemeinek szintaxisa a C programozási nyelvek szintaxisát
            követi, - mint amúgy az ismertebb programozási nyelvek nagyrésze -
            ennek eredménye, hogy a C/C++/C#..-ról áttért programozónak kevés dolga lesz
            a nyelvtana tanulásával, természetesnek fog érződni. A Java szintaxisa
            ráadásul beszédes is, az új funkcionalitások elsajátítása ennek köszönhetően
            villámgyorsan történik. Egy C++ forráskódot probléma nélkül, rövid időn belül
            át tudunk írni Java nyelvre.
        </para>
        <para>
            A Java nyelv ezenkívül engedélyezi, hogy ha akarunk, kiterjesztett
            karakterkészletet is használjunk, tehát például engedélyezi, hogy
            magyar ö,ü... betűket is tartalmazzanak az egyes azonosítók, ugyanakkor
			érdemes az angol ábécé betűihez ragaszkodnunk.
        </para>
		<para>
			Annotációk: Ezzel minden nyelvi elemhez különböző attribútumokat lehet rendelni,
			amit majd különböző segédprogramok használhatnak, pl JUnit.
		</para>
        <para>
            Tulajdonképpen egy speciális interfész, a <type>(kukac)interface</type>
            a típusuk, az annotációs típus interfészek Annotationből erednek.
        </para>
        <para>
            Nem lehetnek generikusak, nem bővíthetnek más interfészt, nem fogalmaznak meg kivételt,
            metódusaik paraméternélküliek, nem definálhatják felül se az Object se az Annotation metódusait.
        </para>

    </section>        

    <section>
        <title>Python</title>
        <para>
            Python: Forstner Bertalan, Ekler Péter, Kelényi Imre: Bevezetés a mobilprogramozásba.
			Gyors prototípus-fejlesztés Python és Java nyelven (35-51 oldal)
        </para>
		<para>
            Itt a kijelölt oldalakból egy 1 oldalas élmény-olvasónaplóra gondoltam.
        </para>
		<para>
			1990-ben Guido van Rossum alkotta meg ezt az általános célú
			programozási nyelvet.
		</para>
        <para>
            A Python egy szkriptnyelv, ami magas szintű, dinamikus, objektumorientált
            és természetesen platformfüggetlen. A nyelv szintaxisát és specifikus
            funcionalitásait nagyon egyszerűen illetve gyorsan el lehet sajátítani, ezenkívül
            rengeteg modullal is érkezik a standard telepítése ami lényegében kickstartolja
            az ezzel a nyelvel megírni kívánt projekteket.
        </para>
		<para>
			Python esetében, mivel interpretált nyelv, nincs szükség
			fordítási részfeladatra, hiszen az interpretor automatikus módon
			tudja futtatni az ezen nyelven megírt alkalmazásunkat. Ez az interpreter
			elérthető rengeteg platformon: Linux disztribúciók, WIndows-ok, MacOS X...
		</para>
        <para>
            Moduláris nyelv, ami azt jelenti, hogy az egyes funkcionalitások
            Python modulként vannak megírva, így hordozhatóak. Ezek a modulok
            adnak lehetőséget a rapid-alkalmazásfejlesztésre ebben a nyelvben.
            Modult alkot például a fájlkezelés vagy a hálózatkezelés.
        </para>
        <para>
            A Python interpreterje akár interaktívan is használható, ez lehetőséget
            ad arra, hogy teszteljük a nyelvünk egyes részeit, vagy akár parancssoros
            környezetként is használhatjuk és még ezeken kívül sok mindenre jó.
        </para>
        <para>
            Pythonnal általában rövid és tömör kódot írunk/állítunk elő, ennek
            okai a következő nyelvtani/szemantikai okok:
        </para>
        <para>
            A blokkok nyitó és zárózárójeleit leváltották az egyszerű szóköz
            vagy a tabulátor.
        </para>
        <para>
            Dinamikusság miatt nem szükséges változót, vagy argumentumot definiálni.
        </para>
        <para>
            Összetett kifejezéseket tömören megtudjuk fogalmazni a magas szintű
            adattípusok miatt.
        </para>
		<para>
			Mivel az utasítások csoportosítása behúzásokkal történik, el kell
			döntenünk, hogy forráskódunkban tabulátort vagy szóközt használunk. A whitespace-ekkel
			való törődés egy plusz "erőfeszítést" vezet be a Python programok írásába, hosszabb
			kódoknál elképzelhető az is, hogy az olvasó számára összefolyik
			a kód, hiszen nincsenek meg a blokkot kijelölő karaktereink, bár 
			ilyen kódok eset inkább az írójával van gond, és nem a nyelvvel.
		</para>
        <para>
            Külön "fejfájást" válthat ki az, hogy Pythonban minden utasítás a sor végéig tart,
            ha több sorba szeretnénk vinni az utasításunkat akkor a <emphasis role='italic'>backslash</emphasis>
            karaktert kell használnunk.
        </para>
        <para>
            További anomália az, hogy minden adatot objektumok reprezentálnak. Javaban
            is szinte minden egyes típus objektum, leszámítva a primitíveket. Az adatok metódusait
            az dönti el, hogy mi lesz objektumának típusa, ez futási időben derül ki, az
            interpreter automatikusan azonosítja a megadott típust. Probléma ezzel ott keletkezik,
            hogy lehetséges, hogy a kódunk olvasó nem fogja egyből tudni, hogy mi éppen
            milyen értékekkel dolgozunk ott, hacsak explicit le nem írjuk kommentben, vagy
            valamilyen típusteszetet végzünk kasztolással.
        </para>
        <para>
            A számok a megszokott típusok mellett lehetnek komplexek is. A JDK-ban például
            nincsen komplex számokkal dolgozó könyvtár, de C++-ban van: <varname>&lt;complex&gt;</varname>.
            Az egészek reprezentációját is megválaszthatjuk, lehet pl hexadecimális megadásban.
        </para>
        <para>
            C++ már van, de előbb Python-nál fordultak elő a <type>tuples</type> típusú
            objektumok. Ezek olyan adatszerkezetek amelyeknek elemei konstansok, tartalma
            nem változtatható.
        </para>

    </section>        
        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
</chapter>       